/*
 * Created on Nov 4, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.framework.simulation;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import yaes.ui.plot.PlotLineDescription;
import yaes.ui.plot.SimulationPlot;

/**
 * @author Lotzi Boloni
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class SimulationHelper {
	// This function is created by Xin on April 6, 2005
	public static void generatePlot(File file,
			List<PlotLineDescription> descriptionList, String title,
			String xLabel, String yLabel) throws IOException {
		final SimulationPlot plot = new SimulationPlot();
		for (final PlotLineDescription pld : descriptionList) {
			final ArrayList<Double> xValues = new ArrayList<Double>();
			final ArrayList<Double> yValues = new ArrayList<Double>();
			for (final SimulationOutput element : pld.getData()) {
				if (pld.contains(element)) {
					xValues.add(new Double(element.getValue(pld.getXVar(), pld
							.getXVarProbe())));
					yValues.add(new Double(element.getValue(pld.getYVar(), pld
							.getYVarProbe())));
				}
			}
			plot.addOnePlot(pld.getLabel(), yValues, "-");
			plot.setXPoints(xValues);
		}
		plot.generateMatlabPlotFileWithTitleLabelLegend(file, title, xLabel,
				yLabel);
	}

	/**
	 * Returns a string with a set of variables printed. Probably should go more
	 * into a helper.
	 * 
	 * @param varsToPrint
	 * @return
	 */
	public static String printVars(SimulationOutput sop, String varsToPrint) {
		final StringBuffer buffer = new StringBuffer("");
		final List<String> vars = new ArrayList<String>();
		for (final Iterator<String> it = sop.getParameterIterator(); it
				.hasNext();) {
			vars.add(it.next());
		}
		Collections.sort(vars);
		for (final String key : vars) {
			if (varsToPrint.indexOf(key) == -1) {
				continue;
			}
			final RandomVariable rv = sop.getRandomVar(key);
			buffer.append("\t" + rv.toString());
		}
		return buffer.toString();
	}
}
