/*
 * Created on Nov 8, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.framework.world.map;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author Lotzi Boloni
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class SegmentHelper {
	/**
	 * Return segment points which -are in the white area -are right before the
	 * path enters a gray area -and right after
	 * 
	 * 
	 * @param path
	 * @param map
	 * @return
	 */
	public static SegmentedPlannedPath segmentOnGrayAreas(PlannedPath path,
			SimpleFreeGround map, IAccessibilityChecker checker,
			Location startLocation, Location endLocation) {
		final ArrayList<Location> segmentLocations = new ArrayList<Location>();
		final SegmentedPlannedPath segPath = new SegmentedPlannedPath();
		final List<Location> fullPath = path.getLocationList();
		Location currentLoc = null;
		Location prevLoc = null;
		boolean insideSafeArea = checker.isAccessible(map, path.getSource());
		for (final Iterator<Location> iter = fullPath.iterator(); iter
				.hasNext();) {
			prevLoc = currentLoc;
			currentLoc = iter.next();
			// you were inside a safe area and the next one is unsafe -->
			// add the previous one to the segment points
			if ((insideSafeArea == true)
					&& (checker.isAccessible(map, currentLoc) == false)) {
				insideSafeArea = false;
				// System.out.println("PrevLoc:"+ prevLoc +
				// ";StartLoc:"+startLocation+";EndLoc:"+endLocation +
				// ";"+prevLoc.locationWithIn(startLocation, endLocation));
				if ((prevLoc != null)
						&& prevLoc.locationWithIn(startLocation, endLocation)) {
					segmentLocations.add(prevLoc);
				}
			}
			// you were inside an unsafe area and the next one is safe - add the
			// next one to segment points
			if ((insideSafeArea == false)
					&& (checker.isAccessible(map, currentLoc) == true)) {
				insideSafeArea = true;
				// System.out.println("currentLoc:"+ currentLoc +
				// ";StartLoc:"+startLocation+";EndLoc:"+endLocation +
				// ";"+currentLoc.locationWithIn(startLocation, endLocation));
				if (currentLoc.locationWithIn(startLocation, endLocation)) {
					segmentLocations.add(currentLoc);
				}
			}
		}
		segPath.setSegmentLocations(segmentLocations);
		return segPath;
	}
}