package yaes.framework.world.network.node.energymodel;

import yaes.framework.world.network.MobileWirelessNode;

public abstract class AbstractEnergyModel implements IEnergyModel {
	private static final double MAX_ENERGY = 100.0;
	protected MobileWirelessNode theNode;
	protected double currentEnergy;
	protected double lastTime;

	public AbstractEnergyModel(MobileWirelessNode theNode) {
		this.theNode = theNode;
		lastTime = 0.0;
		currentEnergy = AbstractEnergyModel.MAX_ENERGY;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see yaes.framework.world.network.node.energymodel.IEnergyModel#getEnergy()
	 */
	public double getEnergy() {
		return currentEnergy;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see yaes.framework.world.network.node.energymodel.IEnergyModel#getMaximumEnergy()
	 */
	public double getMaximumEnergy() {
		return AbstractEnergyModel.MAX_ENERGY;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see yaes.framework.world.network.node.energymodel.IEnergyModel#getNode()
	 */
	public MobileWirelessNode getNode() {
		return theNode;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see networkmodel.nodes.energymodel.IBatteryOperated#setEnergy(double,
	 *      double)
	 */
	public void setEnergy(double energy, double time) {
		this.currentEnergy = energy;
		this.lastTime = time;
	}
}
