package yaes.framework.world.sensornetwork;

import yaes.framework.agent.ACLMessage;

public class Perception {
	public enum PerceptionType {
		ActuatorPresence, Overhearing, ReceivedMessage, NoPerception
	};

	// counter for the unique identifier of the perceptions
	private static int idCounter = 0;
	private final PerceptionType type;
	private final int time;
	private int id;
	private ACLMessage message;

	/**
	 * Used mainly to create a message perception
	 * 
	 * @param type
	 * @param message
	 */
	public Perception(PerceptionType type, ACLMessage message, int time) {
		this.type = type;
		this.message = message;
		this.time = time;
	}

	public Perception(PerceptionType type, int time) {
		this.type = type;
		this.time = time;
		this.id = Perception.idCounter++;
	}

	public int getId() {
		return id;
	}

	public ACLMessage getMessage() {
		return message;
	}

	public int getTime() {
		return time;
	}

	public PerceptionType getType() {
		return type;
	}

	@Override
	public String toString() {
		final StringBuffer buff = new StringBuffer("Perception: " + type
				+ " at: " + time + "\n");
		return buff.toString();
	}
}
