package yaes.ui.propertysheet;

import java.util.Map;

public class ExPropertyTableModel extends PropertyTableModel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	AttributeUtilityManager attrManager;

	public ExPropertyTableModel(Map props) {
		super(props);
	}

	public ExPropertyTableModel(Map props, AttributeUtilityManager attrManager) {
		super(props);
		this.attrManager = attrManager;
	}

	public void addRow(String name, Object value) {
		if (value != null) {
			propertyRows.add(getRowCount(), name);
			setPropertyValue(name, value);
			fireTableRowsInserted(propertyRows.size(), propertyRows.size());
		}
	}

	@Override
	public String format(String propName) {
		String unit = "";
		if (attrManager != null) {
			unit = attrManager.getAttributeUnits(propName);
		}
		return (unit == null) || (unit.length() == 0) ? propName : propName
				+ " (" + unit + ")";
	}

	public int getPropertyRowCount() {
		return getRowCount(); // propertyRows.size();
	}

	@Override
	public String[] getTags(String propName) {
		if (attrManager == null) {
			return null;
		} else {
			return attrManager.getAttributeTags(propName);
		}
	}

	public void removeRow(int row) {
		properties.remove(propertyForRow(row));
		propertyRows.remove(row);
		fireTableRowsDeleted(row, row);
	}
}