package yaes.ui.propertysheet;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class FileExtensionFilter extends javax.swing.filechooser.FileFilter {
	private String m_Description = "";
	private List<String> m_Extensions = new ArrayList<String>();

	public FileExtensionFilter(String description) {
		m_Description = description;
	}

	// Accept all directories and all htm, html files.
	@Override
	public boolean accept(File f) {
		if (f.isDirectory()) {
			return true;
		}
		for (String extension : m_Extensions) {
			if (f.getName().endsWith(extension)) {
				return true;
			}
		}
		return false;
	}

	public void addExtension(String extension) {
		m_Extensions.add(extension);
	}

	// The description of this filter
	@Override
	public String getDescription() {
		return m_Description;
	}
}
