package yaes.ui.propertysheet.editors;

import java.awt.Component;
import java.beans.PropertyEditorSupport;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;

import yaes.ui.propertysheet.EditListWidget;

public abstract class ListEditor extends PropertyEditorSupport {
	private final String delimeter = ",";
	private EditListWidget editListWidget;
	private final int MAX_CHARS = 30;

	public ListEditor() {
	}

	abstract public boolean addOneToken(Vector list, String token);

	@Override
	public Component getCustomEditor() {
		editListWidget = new EditListWidget((Vector) getValue());
		return editListWidget;
	}

	@Override
	public boolean isPaintable() {
		return false;
	}

	public String listToString(Vector dataList) {
		final StringBuffer strBuffer = new StringBuffer();
		if (dataList.isEmpty()) {
			return "";
		}
		final Iterator<?> iter = dataList.iterator();
		while (iter.hasNext()) {
			strBuffer.append(iter.next().toString());
			strBuffer.append(delimeter);
		}
		strBuffer.deleteCharAt(strBuffer.length() - 1);
		if (strBuffer.length() > MAX_CHARS) {
			strBuffer.delete(MAX_CHARS + 1, strBuffer.length() - 1);
			strBuffer.append(",...");
		}
		return strBuffer.toString();
	}

	public void setWidgetList(Vector list) {
		editListWidget.setList(list);
	}

	public Vector stringToList(String s) {
		boolean parseError = false;
		final StringTokenizer st = new StringTokenizer(s, delimeter);
		final Vector tempList = new Vector();
		while (st.hasMoreTokens()) {
			final String str = st.nextToken();
			parseError = addOneToken(tempList, str);
		}
		if (!parseError) {
			return tempList;
		} else {
			return null;
		}
	}

	@Override
	public boolean supportsCustomEditor() {
		return true;
	}
}
