package yaes.ui.propertysheet.editors;

import java.util.Vector;

import yaes.ui.propertysheet.StringList;

public class StringListEditor extends ListEditor {
	private StringList dataList;

	public StringListEditor() {
	}

	@Override
	public boolean addOneToken(Vector list, String token) {
		boolean parseError = false;
		try {
			list.add(token.trim());
		} catch (final Exception exc) {
			parseError = true;
		}
		return parseError;
	}

	@Override
	public String getAsText() {
		return listToString(dataList);
	}

	@Override
	public Object getValue() {
		return dataList;
	}

	@Override
	public void setAsText(String s) {
		final Vector v = stringToList(s);
		if (v != null) {
			setValue(new StringList(v));
		}
	}

	@Override
	public void setValue(Object obj) {
		dataList = (StringList) obj;
		this.firePropertyChange();
	}
}