/*
 * Created on Sep 15, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.ui.visualization;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.geom.Point2D;

import yaes.framework.world.map.IMovingObject;
import yaes.framework.world.map.IPathRecorder;
import yaes.framework.world.map.Location;
import yaes.framework.world.map.Path;

/**
 * @author lboloni
 * 
 */
public class MovingObjectPainter implements IPainter {
	private boolean fill;
	private Color color;
	private boolean paintPath;
	private PathPainter thePathPainter = null;

	public MovingObjectPainter() {
		this.fill = false;
		this.color = Color.BLACK;
		this.paintPath = false;
	}

	public MovingObjectPainter(boolean fill, Color color) {
		this.fill = fill;
		this.color = color;
		setPaintPath(true);
	}

	/**
	 * @return Returns the color.
	 */
	public Color getColor() {
		return color;
	}

	public int getLayer() {
		return 0;
	}

	/**
	 * @return Returns the thePathPainter.
	 */
	public PathPainter getThePathPainter() {
		return thePathPainter;
	}

	/**
	 * @return Returns the fill.
	 */
	public boolean isFill() {
		return fill;
	}

	/**
	 * @return Returns the paintPath.
	 */
	public boolean isPaintPath() {
		return paintPath;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see simulation.visualization.IPainter#paint(java.awt.Graphics2D,
	 *      java.lang.Object)
	 */
	public void paint(Graphics2D g, Object o, VisualMapPanel panel) {
		final IMovingObject movingObject = (IMovingObject) o;
		final int size = 15;
		final Location objectLocation = movingObject.getLocation()
				.getRoundedLocation();
		Point2D.Double point = objectLocation.asPoint();
		panel.getTheTransform().transform(point, point);
		final int x = (int) point.getX();
		final int y = (int) point.getY();
		g.setColor(color);
		if (fill) {
			g.fillOval(x - size / 2, y - size / 2, size, size);
		} else {
			g.drawOval(x - size / 2, y - size / 2, size, size);
		}
		if ((movingObject instanceof IPathRecorder) && paintPath) {
			// paintPath(g, ugv.getRecordedPath());
			final Path recordedPath = ((IPathRecorder) movingObject)
					.getRecordedPath();
			if (recordedPath != null) {
				thePathPainter.paint(g, recordedPath, panel);
			}
		}
	}

	/**
	 * @param color
	 *            The color to set.
	 */
	public void setColor(Color color) {
		this.color = color;
	}

	/**
	 * @param fill
	 *            The fill to set.
	 */
	public void setFill(boolean fill) {
		this.fill = fill;
	}

	/**
	 * @param paintPath
	 *            The paintPath to set.
	 */
	public void setPaintPath(boolean paintPath) {
		if (paintPath == true) {
			thePathPainter = new PathPainter();
		}
		this.paintPath = paintPath;
	}

	/**
	 * @param thePathPainter
	 *            The thePathPainter to set.
	 */
	public void setThePathPainter(PathPainter thePathPainter) {
		this.thePathPainter = thePathPainter;
	}
}