/*
 * Created on Nov 24, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.ui.visualization;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.geom.GeneralPath;
import java.awt.geom.Point2D;

import yaes.framework.world.map.Location;
import yaes.framework.world.map.Path;

public class PathPainter implements IPainter {
	private static final float width = (float) 3.0;
	private static final float dash[] = { 5.0f, 5.0f };
	private static final BasicStroke DASHED = new BasicStroke(
			PathPainter.width, 0, 0, 1.0f, PathPainter.dash, 0.0f);
	private BasicStroke stroke = PathPainter.DASHED;
	// private Color color = Color.BLUE;
	private Color color = Color.BLACK;

	/**
	 * @return Returns the color.
	 */
	public Color getColor() {
		return color;
	}

	public int getLayer() {
		return 1;
	}

	/**
	 * @return Returns the stroke.
	 */
	public BasicStroke getStroke() {
		return stroke;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see yaes.ui.visualization.IPainter#paint(java.awt.Graphics2D,
	 *      java.lang.Object)
	 */
	public void paint(Graphics2D g, Object o, VisualMapPanel panel) {
		final Path plannedPath = (Path) o;
		// TextUi.println("Painting path " + o);
		Location lastLocation = null;
		g.setStroke(stroke);
		g.setColor(color);
		final GeneralPath gp = new GeneralPath();
		synchronized (plannedPath) {
			for (final Location element : plannedPath.getLocationList()) {
				if (lastLocation != null) {
					Point2D.Double point = new Point2D.Double((float) element
							.getX(), (float) element.getY());
					panel.getTheTransform().transform(point, point);
					gp.lineTo(point.x, point.y);
				} else {
					lastLocation = element;
					Point2D.Double point = new Point2D.Double(
							(float) lastLocation.getX(), (float) lastLocation
									.getY());
					panel.getTheTransform().transform(point, point);
					gp.moveTo(point.x, point.y);
				}
			}
		}

		g.draw(gp);
	}

	/**
	 * @param color
	 *            The color to set.
	 */
	public void setColor(Color color) {
		this.color = color;
	}

	/**
	 * @param stroke
	 *            The stroke to set.
	 */
	public void setStroke(BasicStroke stroke) {
		this.stroke = stroke;
	}
}
