package yaes.ui.visualization.application.sensornetwork;

import java.awt.Color;
import java.util.HashMap;

/**
 * This class holds the configuration of the painters
 * 
 * @author Lotzi Boloni
 * 
 */
public class PainterConfiguration extends HashMap<String, Object> {
    
    
  /**
	 * 
	 */
	private static final long serialVersionUID = -5537022757514883571L;
	/*  
	public int secondsToConsider = 3;
	public Color overHearingColor = Color.yellow;
	public boolean paintPerceptionInMobileNode = true;
	public Color sensorRangeColor = Color.BLUE;
	public Color sensorSensingColor = Color.RED;
	public Color transmissionRangeColor = Color.black;
	public boolean paintPerceptionInSensorNode = true;
	public boolean paintSensorRange = false;
	public boolean paintTransmissionRange = false;
    */
    public static final String PCONF_SECONDS_TO_CONSIDER = "Seconds to consider";
    public static final String PCONF_OVERHEARING_COLOR = "Overhearing color";
    public static final String PCONF_PAINT_PERCEPTION_IN_MOBILE_NODE = "Paint perception in mobile node";
    public static final String PCONF_SENSOR_RANGE_COLOR = "Sensor range color";
    public static final String PCONF_SENSOR_SENSING_COLOR = "Sensor sensing color";
    public static final String PCONF_TRANSMISSION_RANGE_COLOR = "Transmission range color";
    public static final String PCONF_PAINT_PERCEPTION_IN_SENSOR_NODE = "Paint perception in sensor node";
    public static final String PCONF_PAINT_SENSOR_RANGE = "Paint sensor range";
    public static final String PCONF_PAINT_TRANSMISSION_RANGE = "Paint transmission range";
    
    public PainterConfiguration() {
    	super();
    	initialize();
    }
    
    public void initialize() {
        put(PCONF_SECONDS_TO_CONSIDER, 1);
        put(PCONF_OVERHEARING_COLOR, Color.YELLOW);
        put(PCONF_PAINT_PERCEPTION_IN_MOBILE_NODE, Boolean.TRUE);
        put(PCONF_SENSOR_RANGE_COLOR, Color.BLUE);
        put(PCONF_SENSOR_SENSING_COLOR, Color.RED);
        put(PCONF_TRANSMISSION_RANGE_COLOR, Color.BLACK);
        put(PCONF_PAINT_PERCEPTION_IN_SENSOR_NODE, Boolean.TRUE);
        put(PCONF_PAINT_SENSOR_RANGE, Boolean.FALSE);
        put(PCONF_PAINT_TRANSMISSION_RANGE, Boolean.FALSE);
    }
    
}
